{**********************************************************************
                PilotLogic Software House.
  
 Package pl_RX.pkg
 This unit is part of CodeTyphon Project (http://www.pilotlogic.com/)
***********************************************************************}

unit allrxregister;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Dialogs,LResources, ComponentEditors,PropEdits, LazarusPackageIntf;


procedure Register;

implementation
{$R allrxregister.res}
uses
  //..............General..................
  folderlister, duallist, RxHistoryNavigator,
  curredit, rxswitch, rxdice, rxtoolbar, rxxpman, PageMngr, RxAppIcon,
  rxctrls,
  RxCustomChartPanel, AutoPanel, pickdate, rxconst, tooledit, rxclock,
  rxceEditLookupFields, rxpopupunit, rxspin, RxTimeEdit,
  RxAboutDialog, RxViewsPanel, RxMDI,RxIniPropStorage, rxDateRangeEditUnit,
  RXHistory,
  rxlazreport,

  //..............DB.......................
  DB, DBPropEdits, rxdbgrid, RxDBSpinEdit, RxDBTimeEdit, RxDBCtrls, rxmemds,
  seldsfrm,  RxDBColorBox, dbdateedit, rxdbcomb,
  rxlookup, dbcurredit, RxDBGridExportSpreadSheet, RxDBGridPrintGrid,
  RxSortSqlDB,RxSortZeos,RxDBGridFooterTools,

  //.................Tools.................
  RxSystemServices, RxLogin, RxVersInfo, RxCloseFormValidator;


resourcestring
  sTestTRxLoginDialog = 'Test TRxLoginDialog';
  sLoadIcon        = 'Load icon';


type
  PClass = ^TClass;

  TRxLoginDialogEditor = class(TComponentEditor)
  public
    DefaultEditor: TBaseComponentEditor;
    constructor Create(AComponent: TComponent; ADesigner: TComponentEditorDesigner); override;
    destructor Destroy; override;
    function GetVerbCount:integer;override;
    function GetVerb(Index:integer):string;override;
    procedure ExecuteVerb(Index:integer);override;
  end;

  TRxAppIconEditor = class(TComponentEditor)
  public
    DefaultEditor: TBaseComponentEditor;
    constructor Create(AComponent: TComponent; ADesigner: TComponentEditorDesigner); override;
    destructor Destroy; override;
    function GetVerbCount:integer;override;
    function GetVerb(Index:integer):string;override;
    procedure ExecuteVerb(Index:integer);override;
  end;


  TPopUpColumnFieldProperty = class(TFieldProperty)
  public
    procedure FillValues(const Values: TStringList); override;
  end;

  THistoryButtonProperty = class(TStringPropertyEditor)
  public
    function  GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

  TRxDBGridFieldProperty = class(TFieldProperty)
  public
    procedure FillValues(const Values: TStringList); override;
  end;

  TRxDBGridFooterFieldProperty = class(TFieldProperty)
  public
    procedure FillValues(const Values: TStringList); override;
  end;

//================== TRxLoginDialogEditor ===========================

constructor TRxLoginDialogEditor.Create(AComponent: TComponent;
  ADesigner: TComponentEditorDesigner);
var
  CompClass: TClass;
begin
  inherited Create(AComponent, ADesigner);
  CompClass := PClass(Acomponent)^;
  try
    PClass(AComponent)^ := TComponent;
    DefaultEditor := GetComponentEditor(AComponent, ADesigner);
  finally
    PClass(AComponent)^ := CompClass;
  end;
end;

destructor TRxLoginDialogEditor.Destroy;
begin
  DefaultEditor.Free;
  inherited Destroy;
end;

function TRxLoginDialogEditor.GetVerbCount: integer;
begin
  Result:=DefaultEditor.GetVerbCount + 1;
end;

function TRxLoginDialogEditor.GetVerb(Index: integer): string;
begin
  if Index < DefaultEditor.GetVerbCount then
    Result := DefaultEditor.GetVerb(Index)
  else
  begin
    case Index - DefaultEditor.GetVerbCount of
      0:Result:=sTestTRxLoginDialog;
    end;
  end;
end;

procedure TRxLoginDialogEditor.ExecuteVerb(Index: integer);
begin
  if Index < DefaultEditor.GetVerbCount then
    DefaultEditor.ExecuteVerb(Index)
  else
  begin
    case Index - DefaultEditor.GetVerbCount of
      0:(Component as TRxLoginDialog).Login;
    end;
  end;
end;

//==================  TRxAppIcon ===============================

constructor TRxAppIconEditor.Create(AComponent: TComponent;
  ADesigner: TComponentEditorDesigner);
var
  CompClass: TClass;
begin
  inherited Create(AComponent, ADesigner);
  CompClass := PClass(Acomponent)^;
  try
    PClass(AComponent)^ := TComponent;
    DefaultEditor := GetComponentEditor(AComponent, ADesigner);
  finally
    PClass(AComponent)^ := CompClass;
  end;
end;

destructor TRxAppIconEditor.Destroy;
begin
  DefaultEditor.Free;
  inherited Destroy;
end;

function TRxAppIconEditor.GetVerbCount: integer;
begin
  Result:=DefaultEditor.GetVerbCount + 1;
end;

function TRxAppIconEditor.GetVerb(Index: integer): string;
begin
  if Index < DefaultEditor.GetVerbCount then
    Result := DefaultEditor.GetVerb(Index)
  else
  begin
    case Index - DefaultEditor.GetVerbCount of
      0:Result:=sLoadIcon;
    end;
  end;
end;

procedure TRxAppIconEditor.ExecuteVerb(Index: integer);
var
  OpenDialog1: TOpenDialog;
begin
  if Index < DefaultEditor.GetVerbCount then
    DefaultEditor.ExecuteVerb(Index)
  else
  begin
    case Index - DefaultEditor.GetVerbCount of
      0:begin
          OpenDialog1:=TOpenDialog.Create(nil);
          OpenDialog1.Filter:=sWindowsIcoFiles;
          try
            if OpenDialog1.Execute then
              (Component as TRxAppIcon).LoadFromFile(OpenDialog1.FileName);
          finally
            OpenDialog1.Free;
          end;
          Modified;
        end;
    end;
  end;
end;

//==================  TPopUpColumnFieldProperty ========================

procedure TPopUpColumnFieldProperty.FillValues(const Values: TStringList);
var
  Column: TPopUpColumn;
  DataSource: TDataSource;
begin
  Column:=TPopUpColumn(GetComponent(0));
  if not (Column is TPopUpColumn) then exit;
  DataSource := TPopUpFormColumns(Column.Collection).PopUpFormOptions.DataSource;
  if Assigned(DataSource) and Assigned(DataSource.DataSet) then
    DataSource.DataSet.GetFieldNames(Values);
end;


//==================  THistoryButtonProperty ==========================

function THistoryButtonProperty.GetAttributes: TPropertyAttributes;
begin
  Result:= [paValueList, paSortList, paMultiSelect];
end;

procedure THistoryButtonProperty.GetValues(Proc: TGetStrProc);
var
  I: Integer;
  Navigator:TRxHistoryNavigator;
begin
  Navigator:=TRxHistoryNavigator(GetComponent(0));
  if Assigned(Navigator) then
  begin
    if Assigned(Navigator.ToolPanel) then
    begin
      for i:=0 to Navigator.ToolPanel.Items.Count - 1 do
      begin
        if Assigned(Navigator.ToolPanel.Items[i].Action) then
          Proc(Navigator.ToolPanel.Items[i].Action.Name);
      end;
    end;
  end;
end;


//==================  TRxDBGridFieldProperty ==============================

procedure TRxDBGridFieldProperty.FillValues(const Values: TStringList);
var
  Column: TRxColumn;
  Grid: TRxDBGrid;
  DataSource: TDataSource;
begin
  Column:=TRxColumn(GetComponent(0));
  if not (Column is TRxColumn) then exit;
  Grid:=TRxDBGrid(Column.Grid);
  if not (Grid is TRxDBGrid) then exit;
  DataSource := Grid.DataSource;
  if Assigned(DataSource) and Assigned(DataSource.DataSet) then
    DataSource.DataSet.GetFieldNames(Values);
end;


//==================  TRxDBGridFieldProperty ===============================

procedure TRxDBGridFooterFieldProperty.FillValues(const Values: TStringList);
var
  Grid: TRxDBGrid;
  DataSource: TDataSource;
begin
  if GetComponent(0) is TRxColumnFooterItem then
    Grid:=TRxDBGrid(TRxColumnFooterItem(GetComponent(0)).Owner.Grid)
  else
(*  if GetComponent(0) is TRxColumnFooter then
    Grid:=TRxDBGrid(TRxColumnFooter(GetComponent(0)).Owner.Grid)
  else *)
    exit;
  if not (Grid is TRxDBGrid) then exit;

  DataSource := Grid.DataSource;
  if Assigned(DataSource) and Assigned(DataSource.DataSet) then
    DataSource.DataSet.GetFieldNames(Values);
end;

// =======================================================
// =======================================================
// =======================================================

procedure Register;
begin

//..............General..................
  RegisterComponents('RX',[
                       {$IFDEF USE_TRxAppIcon}
                           TRxAppIcon,
                       {$ENDIF}
                      {$IFDEF USE_TRXXPManifest}
                           TRXXPManifest,
                       {$ENDIF}
                           TPageManager,
                           TDualListDialog,
                           TCurrencyEdit,
                           TRxSwitch,
                           TRxDice,
                           TFolderLister,
                           TToolPanel,
                           TRxLabel, TSecretPanel, TRxSpeedButton, TRxRadioGroup,
                           TRxChart,
                           TAutoPanel,
                           TRxCalendarGrid,
                           TRxDateEdit, 
                           TRxDateRangeEdit,
                           TRxTimeEdit,
                           TRxClock,
                           TRxSpinButton, TRxSpinEdit,
                           TRxAboutDialog,
                           TRxViewsPanel,
                           TRxMDICloseButton, TRxMDIPanel, TRxMDITasks,
                           TRXHistory
                           ]);

  RegisterComponents('Reports',[TRxReport]);  // from RxLazReport.pas

  RegisterPropertyEditor(TypeInfo(string), TPopUpColumn, 'FieldName', TPopUpColumnFieldProperty);
  RegisterPropertyEditor(TypeInfo(string), TRxHistoryNavigator, 'BackBtn', THistoryButtonProperty);
  RegisterPropertyEditor(TypeInfo(string), TRxHistoryNavigator, 'ForwardBtn', THistoryButtonProperty);
  RegisterCEEditLookupFields;
  RegisterPropertyEditor(TypeInfo(string), TRXHistory, 'PriorButtonName', TTRXHistoryBtnNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TRXHistory, 'NextButtonName', TTRXHistoryBtnNameProperty);
//..............DB.................
  RegisterComponents('RX DBAware',[
                                   TRxDBSpinEdit,
                                   TRxDBTimeEdit,
                                   TRxDBProgressBar, TRxDBTrackBar, TRxDBRadioGroup,
                                   TRxDBGrid,
                                   TRxDBGridFooterTools,
                                   TRxMemoryData,
                                   TRxDBColorBox,

                                   TRxDBDateEdit, TRxDBCalcEdit, TRxDBCurrEdit,
                                   
                                   TRXLookupEdit, TRxDBLookupCombo,
                                   TRxDBComboBox,

                                   TRxDBGridExportSpreadSheet,
                                   TRxDBGridPrint,
                                   TRxSortSqlDB,
                                   TRxSortZeos
                                   ]);

  RegisterComponentEditor(TRxMemoryData, TMemDataSetEditor);
  RegisterPropertyEditor(TypeInfo(string), TRxColumn, 'FieldName', TRxDBGridFieldProperty);
  RegisterPropertyEditor(TypeInfo(string), TRxColumnFooterItem, 'FieldName', TRxDBGridFooterFieldProperty);

//.................Tools.................
  RegisterComponents('RX Tools', [
                                  TRxSystemServices,
                                  TRxLoginDialog,
                                  TRxVersionInfo,
                                  TRxCloseFormValidator,
                                  TRxIniPropStorage,

                                  TRxHistoryNavigator
                                  ]);


  RegisterComponentEditor(TRxLoginDialog, TRxLoginDialogEditor);
  RegisterComponentEditor(TRxAppIcon, TRxAppIconEditor);
end;

// =======================================================
// =======================================================
// =======================================================


end.

